/* CPU class elements for ppcbf.

THIS FILE IS MACHINE GENERATED WITH CGEN.

Copyright (C) 2000, 2001 Red Hat, Inc.

This file is part of the Red Hat simulators.


*/

// This file is included in the middle of the cpu class struct.

public:

// CPU state information.

  // Hardware elements.
  struct {
  /* program counter */
  USI h_pc;
  /* general purpose registers */
  SI h_gpr[32];
  /* special purpose registers */
  SI h_spr[1024];
  /* time base registers */
  SI h_tbr[2];
  /* segment registers */
  SI h_sr[16];
  /* floating point registers */
  DF h_fpr[32];
  /* condition register */
  SI h_cr;
  /* condition register split into 8 parts (cr0 ... cr7) */
  QI h_cr_s[8];
  /* xer/so bit */
  BI h_xer_so;
  /* xer/ov bit */
  BI h_xer_ov;
  /* xer/ca bit */
  BI h_xer_ca;
  /* lr reg */
  SI h_lr;
  /* ctr reg */
  SI h_ctr;
  /* msr reg */
  SI h_msr;
  } hardware;

  // C++ register access function templates
#define current_cpu this

  inline USI h_pc_get () const { return this->hardware.h_pc; }
  inline void h_pc_set (USI newval) { this->hardware.h_pc = newval; }

  inline SI h_gpr_get (UINT regno) const { return this->hardware.h_gpr[regno]; }
  inline void h_gpr_set (UINT regno, SI newval) { this->hardware.h_gpr[regno] = newval; }

  inline SI h_spr_get (UINT regno) const { return (((regno) == (8))) ? (current_cpu->hardware.h_lr) : (((regno) == (9))) ? (current_cpu->hardware.h_ctr) : (current_cpu->hardware.h_spr[regno]); }
  inline void h_spr_set (UINT regno, SI newval) {   switch (regno)
  {
  case 8 : {
current_cpu->hardware.h_lr = newval;
}
    break;
  case 9 : {
current_cpu->hardware.h_ctr = newval;
}
    break;
  default : {
current_cpu->hardware.h_spr[regno] = newval;
}
    break;
  }
 }

  inline SI h_tbr_get (UINT regno) const { return (((regno) == (268))) ? (current_cpu->hardware.h_spr[((UINT) 284)]) : (((regno) == (269))) ? (current_cpu->hardware.h_spr[((UINT) 285)]) : (0); }
  inline void h_tbr_set (UINT regno, SI newval) { this->hardware.h_tbr[regno] = newval; }

  inline SI h_sr_get (UINT regno) const { return this->hardware.h_sr[regno]; }
  inline void h_sr_set (UINT regno, SI newval) { this->hardware.h_sr[regno] = newval; }

  inline DF h_fpr_get (UINT regno) const { return this->hardware.h_fpr[regno]; }
  inline void h_fpr_set (UINT regno, DF newval) { this->hardware.h_fpr[regno] = newval; }

  inline SI h_cr_get () const { return this->hardware.h_cr; }
  inline void h_cr_set (SI newval) { this->hardware.h_cr = newval; }

  inline QI h_cr_s_get (UINT regno) const { return ANDSI (SRLSI (current_cpu->hardware.h_cr, ((((7) - (regno))) * (4))), 15); }
  inline void h_cr_s_set (UINT regno, QI newval) { current_cpu->hardware.h_cr = ORSI (ANDSI (current_cpu->hardware.h_cr, (~ (((15) << (((((7) - (regno))) * (4))))))), SLLQI (newval, ((((7) - (regno))) * (4))));
 }

  inline BI h_xer_so_get () const { return this->hardware.h_xer_so; }
  inline void h_xer_so_set (BI newval) { this->hardware.h_xer_so = newval; }

  inline BI h_xer_ov_get () const { return this->hardware.h_xer_ov; }
  inline void h_xer_ov_set (BI newval) { this->hardware.h_xer_ov = newval; }

  inline BI h_xer_ca_get () const { return this->hardware.h_xer_ca; }
  inline void h_xer_ca_set (BI newval) { this->hardware.h_xer_ca = newval; }

  inline SI h_lr_get () const { return this->hardware.h_lr; }
  inline void h_lr_set (SI newval) { this->hardware.h_lr = newval; }

  inline SI h_ctr_get () const { return this->hardware.h_ctr; }
  inline void h_ctr_set (SI newval) { this->hardware.h_ctr = newval; }

  inline SI h_msr_get () const { return this->hardware.h_msr; }
  inline void h_msr_set (SI newval) { this->hardware.h_msr = newval; }

#undef current_cpu

