/* Decode header for ppc.

THIS FILE IS MACHINE GENERATED WITH CGEN.

Copyright (C) 2000, 2001 Red Hat, Inc.

This file is part of the Red Hat simulators.


*/

#ifndef PPC_DECODE_H
#define PPC_DECODE_H

namespace ppcbf {

using namespace cgen;
using namespace powerpc;

typedef UINT ppc_insn_word;

/* Enum declaration for instructions in cpu family ppc.  */
typedef enum ppc_insn_type {
  PPC_INSN_X_INVALID, PPC_INSN_ADD, PPC_INSN_ADDC, PPC_INSN_ADDE
 , PPC_INSN_ADDME, PPC_INSN_ADDZE, PPC_INSN_ADDIC, PPC_INSN_ADDIC_
 , PPC_INSN_ADDI, PPC_INSN_ADDIS, PPC_INSN_NEG, PPC_INSN_SUBF
 , PPC_INSN_SUBFC, PPC_INSN_SUBFE, PPC_INSN_SUBFME, PPC_INSN_SUBFZE
 , PPC_INSN_DIVW, PPC_INSN_DIVWU, PPC_INSN_SUBFIC, PPC_INSN_MULHW
 , PPC_INSN_MULHWU, PPC_INSN_MULLI, PPC_INSN_MULLW, PPC_INSN_CMPIX
 , PPC_INSN_CMPLIX, PPC_INSN_CMP, PPC_INSN_CMPL, PPC_INSN_AND
 , PPC_INSN_ANDC, PPC_INSN_ANDI_, PPC_INSN_ANDIS_, PPC_INSN_OR
 , PPC_INSN_ORC, PPC_INSN_NOR, PPC_INSN_NAND, PPC_INSN_EQV
 , PPC_INSN_XOR, PPC_INSN_XORI, PPC_INSN_XORIS, PPC_INSN_ORI
 , PPC_INSN_ORIS, PPC_INSN_EXTSB, PPC_INSN_EXTSH, PPC_INSN_RLWIMI
 , PPC_INSN_RLWINM, PPC_INSN_RLWNM, PPC_INSN_SLW, PPC_INSN_SRAW
 , PPC_INSN_SRAWI, PPC_INSN_SRW, PPC_INSN_LBZ, PPC_INSN_LBZU
 , PPC_INSN_LBZUX, PPC_INSN_LBZX, PPC_INSN_LHA, PPC_INSN_LHAU
 , PPC_INSN_LHAUX, PPC_INSN_LHAX, PPC_INSN_LHZ, PPC_INSN_LHZU
 , PPC_INSN_LHZUX, PPC_INSN_LHZX, PPC_INSN_LWZ, PPC_INSN_LWZU
 , PPC_INSN_LWZUX, PPC_INSN_LWZX, PPC_INSN_LHBRX, PPC_INSN_LWBRX
 , PPC_INSN_LWARX, PPC_INSN_LMW, PPC_INSN_STB, PPC_INSN_STBU
 , PPC_INSN_STBUX, PPC_INSN_STBX, PPC_INSN_STH, PPC_INSN_STHU
 , PPC_INSN_STHUX, PPC_INSN_STHX, PPC_INSN_STW, PPC_INSN_STWU
 , PPC_INSN_STWUX, PPC_INSN_STWX, PPC_INSN_STMW, PPC_INSN_TW
 , PPC_INSN_TWI, PPC_INSN_SC, PPC_INSN_RFI, PPC_INSN_B
 , PPC_INSN_BCCTR, PPC_INSN_BCLR, PPC_INSN_BC, PPC_INSN_CRAND
 , PPC_INSN_CROR, PPC_INSN_CRXOR, PPC_INSN_CRANDC, PPC_INSN_CREQV
 , PPC_INSN_CRNAND, PPC_INSN_CRNOR, PPC_INSN_CRORC, PPC_INSN_MCRF
 , PPC_INSN_MCRXR, PPC_INSN_MFCR, PPC_INSN_DCBA, PPC_INSN_DCBF
 , PPC_INSN_DCBI, PPC_INSN_DCBST, PPC_INSN_DCBT, PPC_INSN_DCBTST
 , PPC_INSN_DCBZ, PPC_INSN_ICBI, PPC_INSN_ISYNC, PPC_INSN_SYNC
 , PPC_INSN_TLBIA, PPC_INSN_TLBSYNC, PPC_INSN_TLBIE, PPC_INSN_ECIWX
 , PPC_INSN_ECOWX, PPC_INSN_EIEIO, PPC_INSN_MFMSR, PPC_INSN_MTMSR
 , PPC_INSN_MFSPR, PPC_INSN_MTSPR, PPC_INSN_MTSR, PPC_INSN_MFSR
 , PPC_INSN_MFTB
} PPC_INSN_TYPE;


// Forward decls.
struct ppcbf_cpu;
struct ppc_scache;
typedef sem_status (ppc_sem_fn) (ppcbf_cpu* cpu, ppc_scache* sem);


// Instruction descriptor.

struct ppc_idesc {

  // scache engine executor for this insn
  ppc_sem_fn* execute;

  const char* insn_name;
  enum ppc_insn_type sem_index;
  powerpc_insn_attr attrs;

  // idesc table: indexed by sem_index
  static ppc_idesc idesc_table[];

  static ppc_insn_type lookup_virtual (virtual_insn_type vit);
};

// Instruction argument buffer.

union ppc_sem_fields {
  struct { /* no operands */
    int empty;
  } fmt_empty;
  struct { /*  */
    UINT f_rd;
    UINT f_tbr;
  } sfmt_mftb;
  struct { /*  */
    UINT f_rd;
    UINT f_sr;
  } sfmt_mfsr;
  struct { /*  */
    UINT f_rs;
    UINT f_sr;
  } sfmt_mtsr;
  struct { /*  */
    UINT f_rs;
    UINT f_spr;
  } sfmt_mtspr;
  struct { /*  */
    UINT f_rd;
    UINT f_spr;
  } sfmt_mfspr;
  struct { /*  */
    UINT f_crfd;
    UINT f_crfs;
  } sfmt_mcrf;
  struct { /*  */
    UINT f_crba;
    UINT f_crbb;
    UINT f_crbd;
  } sfmt_crand;
  struct { /*  */
    IADDR i_li;
    UINT f_aa;
    UINT f_lk;
  } sfmt_b;
  struct { /*  */
    INT f_simm;
    UINT f_ra;
    UINT f_to;
  } sfmt_twi;
  struct { /*  */
    UINT f_ra;
    UINT f_rb;
    UINT f_to;
  } sfmt_tw;
  struct { /*  */
    INT f_d;
    UINT f_ra;
    UINT f_rs;
  } sfmt_stb;
  struct { /*  */
    INT f_d;
    UINT f_ra;
    UINT f_rd;
  } sfmt_lbz;
  struct { /*  */
    UINT f_ra;
    UINT f_rs;
    UINT f_uimm;
  } sfmt_andi_;
  struct { /*  */
    UINT f_crfd;
    UINT f_ra;
    UINT f_rb;
  } sfmt_cmp;
  struct { /*  */
    UINT f_crfd;
    UINT f_ra;
    UINT f_uimm;
  } sfmt_cmplix;
  struct { /*  */
    INT f_simm;
    UINT f_crfd;
    UINT f_ra;
  } sfmt_cmpix;
  struct { /*  */
    INT f_simm;
    UINT f_ra;
    UINT f_rc;
    UINT f_rd;
  } sfmt_mulli;
  struct { /*  */
    IADDR i_bd;
    UINT f_aa;
    UINT f_bi;
    UINT f_bo;
    UINT f_lk;
  } sfmt_bc;
  struct { /*  */
    UINT f_oe;
    UINT f_ra;
    UINT f_rb;
    UINT f_rc;
    UINT f_rd;
  } sfmt_add;
  struct { /*  */
    UINT f_mb;
    UINT f_me;
    UINT f_ra;
    UINT f_rb;
    UINT f_rc;
    UINT f_rs;
  } sfmt_rlwnm;
  struct { /*  */
    UINT f_mb;
    UINT f_me;
    UINT f_ra;
    UINT f_rc;
    UINT f_rs;
    UINT f_sh;
  } sfmt_rlwimi;
  // This one is for chain/cti-chain virtual insns.
  struct {
    // Number of insns in pbb.
    unsigned insn_count;
    // This is used by chain insns and by untaken conditional branches.
    ppc_scache* next;
    ppc_scache* branch_target;
  } chain;
  // This one is for `before' virtual insns.
  struct {
    // The cache entry of the real insn.
    ppc_scache* insn;
  } before;
};

// Simulator instruction cache.

struct ppc_scache {
  // executor
  union {
    cgoto_label cgoto;
    ppc_sem_fn* fn;
  } execute;

  // PC of this instruction.
  PCADDR addr;

  // instruction class
  ppc_idesc* idesc;

  // argument buffer
  ppc_sem_fields fields;



  // decode given instruction
  void decode (ppcbf_cpu* current_cpu, PCADDR pc, ppc_insn_word base_insn, ppc_insn_word entire_insn);
};

} // end ppcbf namespace

// Decls of each semantic fn.

using ppcbf::ppc_sem_fn;
extern ppc_sem_fn ppc_sem_x_invalid;
extern ppc_sem_fn ppc_sem_add;
extern ppc_sem_fn ppc_sem_addc;
extern ppc_sem_fn ppc_sem_adde;
extern ppc_sem_fn ppc_sem_addme;
extern ppc_sem_fn ppc_sem_addze;
extern ppc_sem_fn ppc_sem_addic;
extern ppc_sem_fn ppc_sem_addic_;
extern ppc_sem_fn ppc_sem_addi;
extern ppc_sem_fn ppc_sem_addis;
extern ppc_sem_fn ppc_sem_neg;
extern ppc_sem_fn ppc_sem_subf;
extern ppc_sem_fn ppc_sem_subfc;
extern ppc_sem_fn ppc_sem_subfe;
extern ppc_sem_fn ppc_sem_subfme;
extern ppc_sem_fn ppc_sem_subfze;
extern ppc_sem_fn ppc_sem_divw;
extern ppc_sem_fn ppc_sem_divwu;
extern ppc_sem_fn ppc_sem_subfic;
extern ppc_sem_fn ppc_sem_mulhw;
extern ppc_sem_fn ppc_sem_mulhwu;
extern ppc_sem_fn ppc_sem_mulli;
extern ppc_sem_fn ppc_sem_mullw;
extern ppc_sem_fn ppc_sem_cmpix;
extern ppc_sem_fn ppc_sem_cmplix;
extern ppc_sem_fn ppc_sem_cmp;
extern ppc_sem_fn ppc_sem_cmpl;
extern ppc_sem_fn ppc_sem_and;
extern ppc_sem_fn ppc_sem_andc;
extern ppc_sem_fn ppc_sem_andi_;
extern ppc_sem_fn ppc_sem_andis_;
extern ppc_sem_fn ppc_sem_or;
extern ppc_sem_fn ppc_sem_orc;
extern ppc_sem_fn ppc_sem_nor;
extern ppc_sem_fn ppc_sem_nand;
extern ppc_sem_fn ppc_sem_eqv;
extern ppc_sem_fn ppc_sem_xor;
extern ppc_sem_fn ppc_sem_xori;
extern ppc_sem_fn ppc_sem_xoris;
extern ppc_sem_fn ppc_sem_ori;
extern ppc_sem_fn ppc_sem_oris;
extern ppc_sem_fn ppc_sem_extsb;
extern ppc_sem_fn ppc_sem_extsh;
extern ppc_sem_fn ppc_sem_rlwimi;
extern ppc_sem_fn ppc_sem_rlwinm;
extern ppc_sem_fn ppc_sem_rlwnm;
extern ppc_sem_fn ppc_sem_slw;
extern ppc_sem_fn ppc_sem_sraw;
extern ppc_sem_fn ppc_sem_srawi;
extern ppc_sem_fn ppc_sem_srw;
extern ppc_sem_fn ppc_sem_lbz;
extern ppc_sem_fn ppc_sem_lbzu;
extern ppc_sem_fn ppc_sem_lbzux;
extern ppc_sem_fn ppc_sem_lbzx;
extern ppc_sem_fn ppc_sem_lha;
extern ppc_sem_fn ppc_sem_lhau;
extern ppc_sem_fn ppc_sem_lhaux;
extern ppc_sem_fn ppc_sem_lhax;
extern ppc_sem_fn ppc_sem_lhz;
extern ppc_sem_fn ppc_sem_lhzu;
extern ppc_sem_fn ppc_sem_lhzux;
extern ppc_sem_fn ppc_sem_lhzx;
extern ppc_sem_fn ppc_sem_lwz;
extern ppc_sem_fn ppc_sem_lwzu;
extern ppc_sem_fn ppc_sem_lwzux;
extern ppc_sem_fn ppc_sem_lwzx;
extern ppc_sem_fn ppc_sem_lhbrx;
extern ppc_sem_fn ppc_sem_lwbrx;
extern ppc_sem_fn ppc_sem_lwarx;
extern ppc_sem_fn ppc_sem_lmw;
extern ppc_sem_fn ppc_sem_stb;
extern ppc_sem_fn ppc_sem_stbu;
extern ppc_sem_fn ppc_sem_stbux;
extern ppc_sem_fn ppc_sem_stbx;
extern ppc_sem_fn ppc_sem_sth;
extern ppc_sem_fn ppc_sem_sthu;
extern ppc_sem_fn ppc_sem_sthux;
extern ppc_sem_fn ppc_sem_sthx;
extern ppc_sem_fn ppc_sem_stw;
extern ppc_sem_fn ppc_sem_stwu;
extern ppc_sem_fn ppc_sem_stwux;
extern ppc_sem_fn ppc_sem_stwx;
extern ppc_sem_fn ppc_sem_stmw;
extern ppc_sem_fn ppc_sem_tw;
extern ppc_sem_fn ppc_sem_twi;
extern ppc_sem_fn ppc_sem_sc;
extern ppc_sem_fn ppc_sem_rfi;
extern ppc_sem_fn ppc_sem_b;
extern ppc_sem_fn ppc_sem_bcctr;
extern ppc_sem_fn ppc_sem_bclr;
extern ppc_sem_fn ppc_sem_bc;
extern ppc_sem_fn ppc_sem_crand;
extern ppc_sem_fn ppc_sem_cror;
extern ppc_sem_fn ppc_sem_crxor;
extern ppc_sem_fn ppc_sem_crandc;
extern ppc_sem_fn ppc_sem_creqv;
extern ppc_sem_fn ppc_sem_crnand;
extern ppc_sem_fn ppc_sem_crnor;
extern ppc_sem_fn ppc_sem_crorc;
extern ppc_sem_fn ppc_sem_mcrf;
extern ppc_sem_fn ppc_sem_mcrxr;
extern ppc_sem_fn ppc_sem_mfcr;
extern ppc_sem_fn ppc_sem_dcba;
extern ppc_sem_fn ppc_sem_dcbf;
extern ppc_sem_fn ppc_sem_dcbi;
extern ppc_sem_fn ppc_sem_dcbst;
extern ppc_sem_fn ppc_sem_dcbt;
extern ppc_sem_fn ppc_sem_dcbtst;
extern ppc_sem_fn ppc_sem_dcbz;
extern ppc_sem_fn ppc_sem_icbi;
extern ppc_sem_fn ppc_sem_isync;
extern ppc_sem_fn ppc_sem_sync;
extern ppc_sem_fn ppc_sem_tlbia;
extern ppc_sem_fn ppc_sem_tlbsync;
extern ppc_sem_fn ppc_sem_tlbie;
extern ppc_sem_fn ppc_sem_eciwx;
extern ppc_sem_fn ppc_sem_ecowx;
extern ppc_sem_fn ppc_sem_eieio;
extern ppc_sem_fn ppc_sem_mfmsr;
extern ppc_sem_fn ppc_sem_mtmsr;
extern ppc_sem_fn ppc_sem_mfspr;
extern ppc_sem_fn ppc_sem_mtspr;
extern ppc_sem_fn ppc_sem_mtsr;
extern ppc_sem_fn ppc_sem_mfsr;
extern ppc_sem_fn ppc_sem_mftb;

#endif /* PPC_DECODE_H */
